diff --git a/gcc/tree-ssa-ccp.c b/gcc/tree-ssa-ccp.c
index 7311f5e..065dbd3 100644
--- a/gcc/tree-ssa-ccp.c
+++ b/gcc/tree-ssa-ccp.c
@@ -275,7 +275,7 @@ static prop_value_t
 get_default_value (tree var)
 {
   prop_value_t val = { UNINITIALIZED, NULL_TREE, 0 };
-  gimple stmt;
+  gimple *stmt;
 
   stmt = SSA_NAME_DEF_STMT (var);
 
@@ -626,7 +626,7 @@ get_value_for_expr (tree expr, bool for_bits_p)
    Else return VARYING.  */
 
 static ccp_lattice_t
-likely_value (gimple stmt)
+likely_value (gimple *stmt)
 {
   bool has_constant_operand, has_undefined_operand, all_undefined_operands;
   tree use;
@@ -745,7 +745,7 @@ likely_value (gimple stmt)
 /* Returns true if STMT cannot be constant.  */
 
 static bool
-surely_varying_stmt_p (gimple stmt)
+surely_varying_stmt_p (gimple *stmt)
 {
   /* If the statement has operands that we cannot handle, it cannot be
      constant.  */
@@ -800,7 +800,7 @@ ccp_initialize (void)
 
       for (i = gsi_start_bb (bb); !gsi_end_p (i); gsi_next (&i))
         {
-	  gimple stmt = gsi_stmt (i);
+	  gimple *stmt = gsi_stmt (i);
 	  bool is_varying;
 
 	  /* If the statement is a control insn, then we do not
@@ -834,7 +834,7 @@ ccp_initialize (void)
 
       for (i = gsi_start_phis (bb); !gsi_end_p (i); gsi_next (&i))
         {
-          gimple phi = gsi_stmt (i);
+          gimple *phi = gsi_stmt (i);
 
 	  if (virtual_operand_p (gimple_phi_result (phi)))
             prop_set_simulate_again (phi, false);
@@ -1019,7 +1019,7 @@ ccp_lattice_meet (prop_value_t *val1, prop_value_t *val2)
    of the PHI node that are incoming via executable edges.  */
 
 static enum ssa_prop_result
-ccp_visit_phi_node (gimple phi)
+ccp_visit_phi_node (gimple *phi)
 {
   unsigned i;
   prop_value_t *old_val, new_val;
@@ -1127,7 +1127,7 @@ valueize_op (tree op)
    otherwise return the original RHS or NULL_TREE.  */
 
 static tree
-ccp_fold (gimple stmt)
+ccp_fold (gimple *stmt)
 {
   location_t loc = gimple_location (stmt);
   switch (gimple_code (stmt))
@@ -1532,7 +1532,7 @@ bit_value_binop (enum tree_code code, tree type, tree rhs1, tree rhs2)
    ALLOC_ALIGNED is true.  */
 
 static prop_value_t
-bit_value_assume_aligned (gimple stmt, tree attr, prop_value_t ptrval,
+bit_value_assume_aligned (gimple *stmt, tree attr, prop_value_t ptrval,
 			  bool alloc_aligned)
 {
   tree align, misalign = NULL_TREE, type;
@@ -1632,7 +1632,7 @@ bit_value_assume_aligned (gimple stmt, tree attr, prop_value_t ptrval,
    Valid only for assignments, calls, conditionals, and switches. */
 
 static prop_value_t
-evaluate_stmt (gimple stmt)
+evaluate_stmt (gimple *stmt)
 {
   prop_value_t val;
   tree simplified = NULL_TREE;
@@ -1904,11 +1904,11 @@ static void
 insert_clobber_before_stack_restore (tree saved_val, tree var,
 				     gimple_htab *visited)
 {
-  gimple stmt, clobber_stmt;
+  gimple *stmt, *clobber_stmt;
   tree clobber;
   imm_use_iterator iter;
   gimple_stmt_iterator i;
-  gimple *slot;
+  gimple **slot;
 
   FOR_EACH_IMM_USE_STMT (stmt, iter, saved_val)
     if (gimple_call_builtin_p (stmt, BUILT_IN_STACK_RESTORE))
@@ -1970,7 +1970,7 @@ gsi_prev_dom_bb_nondebug (gimple_stmt_iterator *i)
 static void
 insert_clobbers_for_var (gimple_stmt_iterator i, tree var)
 {
-  gimple stmt;
+  gimple *stmt;
   tree saved_val;
   gimple_htab visited;
 
@@ -1998,7 +1998,7 @@ insert_clobbers_for_var (gimple_stmt_iterator i, tree var)
    NULL_TREE.  */
 
 static tree
-fold_builtin_alloca_with_align (gimple stmt)
+fold_builtin_alloca_with_align (gimple *stmt)
 {
   unsigned HOST_WIDE_INT size, threshold, n_elem;
   tree lhs, arg, block, var, elem_type, array_type;
@@ -2056,7 +2056,7 @@ fold_builtin_alloca_with_align (gimple stmt)
 static bool
 ccp_fold_stmt (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
 
   switch (gimple_code (stmt))
     {
@@ -2195,7 +2195,7 @@ ccp_fold_stmt (gimple_stmt_iterator *gsi)
    are handled here.  */
 
 static enum ssa_prop_result
-visit_assignment (gimple stmt, tree *output_p)
+visit_assignment (gimple *stmt, tree *output_p)
 {
   prop_value_t val;
   enum ssa_prop_result retval;
@@ -2240,7 +2240,7 @@ visit_assignment (gimple stmt, tree *output_p)
    SSA_PROP_VARYING.  */
 
 static enum ssa_prop_result
-visit_cond_stmt (gimple stmt, edge *taken_edge_p)
+visit_cond_stmt (gimple *stmt, edge *taken_edge_p)
 {
   prop_value_t val;
   basic_block block;
@@ -2273,7 +2273,7 @@ visit_cond_stmt (gimple stmt, edge *taken_edge_p)
    value, return SSA_PROP_VARYING.  */
 
 static enum ssa_prop_result
-ccp_visit_stmt (gimple stmt, edge *taken_edge_p, tree *output_p)
+ccp_visit_stmt (gimple *stmt, edge *taken_edge_p, tree *output_p)
 {
   tree def;
   ssa_op_iter iter;
@@ -2394,10 +2394,10 @@ static tree
 optimize_stack_restore (gimple_stmt_iterator i)
 {
   tree callee;
-  gimple stmt;
+  gimple *stmt;
 
   basic_block bb = gsi_bb (i);
-  gimple call = gsi_stmt (i);
+  gimple *call = gsi_stmt (i);
 
   if (gimple_code (call) != GIMPLE_CALL
       || gimple_call_num_args (call) != 1
@@ -2448,7 +2448,7 @@ optimize_stack_restore (gimple_stmt_iterator i)
      or not is irrelevant to removing the call to __builtin_stack_restore.  */
   if (has_single_use (gimple_call_arg (call, 0)))
     {
-      gimple stack_save = SSA_NAME_DEF_STMT (gimple_call_arg (call, 0));
+      gimple *stack_save = SSA_NAME_DEF_STMT (gimple_call_arg (call, 0));
       if (is_gimple_call (stack_save))
 	{
 	  callee = gimple_call_fndecl (stack_save);
@@ -2476,7 +2476,7 @@ optimize_stack_restore (gimple_stmt_iterator i)
    pointer assignment.  */
 
 static tree
-optimize_stdarg_builtin (gimple call)
+optimize_stdarg_builtin (gimple *call)
 {
   tree callee, lhs, rhs, cfun_va_list;
   bool va_list_simple_ptr;
@@ -2554,7 +2554,7 @@ optimize_unreachable (gimple_stmt_iterator i)
 {
   basic_block bb = gsi_bb (i);
   gimple_stmt_iterator gsi;
-  gimple stmt;
+  gimple *stmt;
   edge_iterator ei;
   edge e;
   bool ret;
@@ -2656,7 +2656,7 @@ pass_fold_builtins::execute (function *fun)
       gimple_stmt_iterator i;
       for (i = gsi_start_bb (bb); !gsi_end_p (i); )
 	{
-          gimple stmt, old_stmt;
+          gimple *stmt, *old_stmt;
 	  tree callee, result;
 	  enum built_in_function fcode;
 
diff --git a/gcc/tree-ssa-coalesce.c b/gcc/tree-ssa-coalesce.c
index 9a1ac67..9757f12 100644
--- a/gcc/tree-ssa-coalesce.c
+++ b/gcc/tree-ssa-coalesce.c
@@ -831,7 +831,7 @@ build_ssa_conflict_graph (tree_live_info_p liveinfo)
       for (gsi = gsi_last_bb (bb); !gsi_end_p (gsi); gsi_prev (&gsi))
         {
 	  tree var;
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 
 	  /* A copy between 2 partitions does not introduce an interference
 	     by itself.  If they did, you would never be able to coalesce
@@ -867,7 +867,7 @@ build_ssa_conflict_graph (tree_live_info_p liveinfo)
 	 may create incorrect code.  */
       for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 	  tree result = PHI_RESULT (phi);
 	  if (live_track_live_p (live, result))
 	    live_track_process_def (live, result, graph);
@@ -920,7 +920,7 @@ create_outofssa_var_map (coalesce_list_p cl, bitmap used_in_copy)
   gimple_stmt_iterator gsi;
   basic_block bb;
   tree var;
-  gimple stmt;
+  gimple *stmt;
   tree first;
   var_map map;
   ssa_op_iter iter;
@@ -935,7 +935,7 @@ create_outofssa_var_map (coalesce_list_p cl, bitmap used_in_copy)
 
       for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 	  size_t i;
 	  int ver;
 	  tree res;
@@ -1192,7 +1192,7 @@ coalesce_partitions (var_map map, ssa_conflicts_p graph, coalesce_list_p cl,
 	    for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi);
 		 gsi_next (&gsi))
 	      {
-		gimple phi = gsi_stmt (gsi);
+		gimple *phi = gsi_stmt (gsi);
 		tree res = PHI_RESULT (phi);
 	        tree arg = PHI_ARG_DEF (phi, e->dest_idx);
 		int v1 = SSA_NAME_VERSION (res);
diff --git a/gcc/tree-ssa-copy.c b/gcc/tree-ssa-copy.c
index 0c14216..e2e5974 100644
--- a/gcc/tree-ssa-copy.c
+++ b/gcc/tree-ssa-copy.c
@@ -87,7 +87,7 @@ static unsigned n_copy_of;
 /* Return true if this statement may generate a useful copy.  */
 
 static bool
-stmt_may_generate_copy (gimple stmt)
+stmt_may_generate_copy (gimple *stmt)
 {
   if (gimple_code (stmt) == GIMPLE_PHI)
     return !SSA_NAME_OCCURS_IN_ABNORMAL_PHI (gimple_phi_result (stmt));
@@ -200,7 +200,7 @@ dump_copy_of (FILE *file, tree var)
    value and store the LHS into *RESULT_P.  */
 
 static enum ssa_prop_result
-copy_prop_visit_assignment (gimple stmt, tree *result_p)
+copy_prop_visit_assignment (gimple *stmt, tree *result_p)
 {
   tree lhs, rhs;
 
@@ -230,7 +230,7 @@ copy_prop_visit_assignment (gimple stmt, tree *result_p)
    SSA_PROP_VARYING.  */
 
 static enum ssa_prop_result
-copy_prop_visit_cond_stmt (gimple stmt, edge *taken_edge_p)
+copy_prop_visit_cond_stmt (gimple *stmt, edge *taken_edge_p)
 {
   enum ssa_prop_result retval = SSA_PROP_VARYING;
   location_t loc = gimple_location (stmt);
@@ -288,7 +288,7 @@ copy_prop_visit_cond_stmt (gimple stmt, edge *taken_edge_p)
    SSA_PROP_VARYING.  */
 
 static enum ssa_prop_result
-copy_prop_visit_stmt (gimple stmt, edge *taken_edge_p, tree *result_p)
+copy_prop_visit_stmt (gimple *stmt, edge *taken_edge_p, tree *result_p)
 {
   enum ssa_prop_result retval;
 
@@ -342,7 +342,7 @@ copy_prop_visit_stmt (gimple stmt, edge *taken_edge_p, tree *result_p)
    set it to be the value of the LHS of PHI.  */
 
 static enum ssa_prop_result
-copy_prop_visit_phi_node (gimple phi)
+copy_prop_visit_phi_node (gimple *phi)
 {
   enum ssa_prop_result retval;
   unsigned i;
@@ -476,7 +476,7 @@ init_copy_prop (void)
 
       for (si = gsi_start_bb (bb); !gsi_end_p (si); gsi_next (&si))
 	{
-	  gimple stmt = gsi_stmt (si);
+	  gimple *stmt = gsi_stmt (si);
 	  ssa_op_iter iter;
           tree def;
 
@@ -511,7 +511,7 @@ init_copy_prop (void)
 
       for (si = gsi_start_phis (bb); !gsi_end_p (si); gsi_next (&si))
 	{
-          gimple phi = gsi_stmt (si);
+          gimple *phi = gsi_stmt (si);
           tree def;
 
 	  def = gimple_phi_result (phi);
diff --git a/gcc/tree-ssa-copyrename.c b/gcc/tree-ssa-copyrename.c
index 89437d9..4c9fa15 100644
--- a/gcc/tree-ssa-copyrename.c
+++ b/gcc/tree-ssa-copyrename.c
@@ -342,7 +342,7 @@ pass_rename_ssa_copies::execute (function *fun)
   basic_block bb;
   gimple_stmt_iterator gsi;
   tree var, part_var;
-  gimple stmt, phi;
+  gimple *stmt, *phi;
   unsigned x;
   FILE *debug;
 
diff --git a/gcc/tree-ssa-dce.c b/gcc/tree-ssa-dce.c
index 4969b11..ce053f0 100644
--- a/gcc/tree-ssa-dce.c
+++ b/gcc/tree-ssa-dce.c
@@ -84,7 +84,7 @@ static struct stmt_stats
 
 #define STMT_NECESSARY GF_PLF_1
 
-static vec<gimple> worklist;
+static vec<gimple *> worklist;
 
 /* Vector indicating an SSA name has already been processed and marked
    as necessary.  */
@@ -122,7 +122,7 @@ static bool cfg_altered;
    worklist if ADD_TO_WORKLIST is true.  */
 
 static inline void
-mark_stmt_necessary (gimple stmt, bool add_to_worklist)
+mark_stmt_necessary (gimple *stmt, bool add_to_worklist)
 {
   gcc_assert (stmt);
 
@@ -149,7 +149,7 @@ mark_stmt_necessary (gimple stmt, bool add_to_worklist)
 static inline void
 mark_operand_necessary (tree op)
 {
-  gimple stmt;
+  gimple *stmt;
   int ver;
 
   gcc_assert (op);
@@ -192,7 +192,7 @@ mark_operand_necessary (tree op)
    necessary.  */
 
 static void
-mark_stmt_if_obviously_necessary (gimple stmt, bool aggressive)
+mark_stmt_if_obviously_necessary (gimple *stmt, bool aggressive)
 {
   /* With non-call exceptions, we have to assume that all statements could
      throw.  If a statement could throw, it can be deemed necessary.  */
@@ -311,7 +311,7 @@ mark_stmt_if_obviously_necessary (gimple stmt, bool aggressive)
 static void
 mark_last_stmt_necessary (basic_block bb)
 {
-  gimple stmt = last_stmt (bb);
+  gimple *stmt = last_stmt (bb);
 
   bitmap_set_bit (last_stmt_necessary, bb->index);
   bitmap_set_bit (bb_contains_live_stmts, bb->index);
@@ -372,7 +372,7 @@ find_obviously_necessary_stmts (bool aggressive)
   basic_block bb;
   gimple_stmt_iterator gsi;
   edge e;
-  gimple phi, stmt;
+  gimple *phi, *stmt;
   int flags;
 
   FOR_EACH_BB_FN (bb, cfun)
@@ -462,7 +462,7 @@ static bool chain_ovfl = false;
 static bool
 mark_aliased_reaching_defs_necessary_1 (ao_ref *ref, tree vdef, void *data)
 {
-  gimple def_stmt = SSA_NAME_DEF_STMT (vdef);
+  gimple *def_stmt = SSA_NAME_DEF_STMT (vdef);
 
   /* All stmts we visit are necessary.  */
   mark_operand_necessary (vdef);
@@ -518,7 +518,7 @@ mark_aliased_reaching_defs_necessary_1 (ao_ref *ref, tree vdef, void *data)
 }
 
 static void
-mark_aliased_reaching_defs_necessary (gimple stmt, tree ref)
+mark_aliased_reaching_defs_necessary (gimple *stmt, tree ref)
 {
   unsigned int chain;
   ao_ref refd;
@@ -543,7 +543,7 @@ static bool
 mark_all_reaching_defs_necessary_1 (ao_ref *ref ATTRIBUTE_UNUSED,
 				    tree vdef, void *data ATTRIBUTE_UNUSED)
 {
-  gimple def_stmt = SSA_NAME_DEF_STMT (vdef);
+  gimple *def_stmt = SSA_NAME_DEF_STMT (vdef);
 
   /* We have to skip already visited (and thus necessary) statements
      to make the chaining work after we dropped back to simple mode.  */
@@ -591,7 +591,7 @@ mark_all_reaching_defs_necessary_1 (ao_ref *ref ATTRIBUTE_UNUSED,
 }
 
 static void
-mark_all_reaching_defs_necessary (gimple stmt)
+mark_all_reaching_defs_necessary (gimple *stmt)
 {
   walk_aliased_vdefs (NULL, gimple_vuse (stmt),
 		      mark_all_reaching_defs_necessary_1, NULL, &visited);
@@ -600,7 +600,7 @@ mark_all_reaching_defs_necessary (gimple stmt)
 /* Return true for PHI nodes with one or identical arguments
    can be removed.  */
 static bool
-degenerate_phi_p (gimple phi)
+degenerate_phi_p (gimple *phi)
 {
   unsigned int i;
   tree op = gimple_phi_arg_def (phi, 0);
@@ -620,7 +620,7 @@ degenerate_phi_p (gimple phi)
 static void
 propagate_necessity (bool aggressive)
 {
-  gimple stmt;
+  gimple *stmt;
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     fprintf (dump_file, "\nProcessing worklist:\n");
@@ -770,7 +770,7 @@ propagate_necessity (bool aggressive)
 	  if (gimple_call_builtin_p (stmt, BUILT_IN_FREE))
 	    {
 	      tree ptr = gimple_call_arg (stmt, 0);
-	      gimple def_stmt;
+	      gimple *def_stmt;
 	      tree def_callee;
 	      /* If the pointer we free is defined by an allocation
 		 function do not add the call to the worklist.  */
@@ -933,7 +933,7 @@ static bool
 remove_dead_phis (basic_block bb)
 {
   bool something_changed = false;
-  gimple phi;
+  gimple *phi;
   gimple_stmt_iterator gsi;
 
   for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi);)
@@ -954,7 +954,7 @@ remove_dead_phis (basic_block bb)
 
 	      use_operand_p use_p;
 	      imm_use_iterator iter;
-	      gimple use_stmt;
+	      gimple *use_stmt;
 	      FOR_EACH_IMM_USE_STMT (use_stmt, iter, vdef)
 		FOR_EACH_IMM_USE_ON_STMT (use_p, iter)
 		  SET_USE (use_p, vuse);
@@ -1015,7 +1015,7 @@ forward_edge_to_pdom (edge e, basic_block post_dom_bb)
 	  break;
       for (gsi = gsi_start_phis (post_dom_bb); !gsi_end_p (gsi);)
 	{
-	  gimple phi = gsi_stmt (gsi);
+	  gimple *phi = gsi_stmt (gsi);
 	  tree op;
 	  source_location locus;
 
@@ -1052,7 +1052,7 @@ forward_edge_to_pdom (edge e, basic_block post_dom_bb)
 static void
 remove_dead_stmt (gimple_stmt_iterator *i, basic_block bb)
 {
-  gimple stmt = gsi_stmt (*i);
+  gimple *stmt = gsi_stmt (*i);
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     {
@@ -1125,7 +1125,7 @@ remove_dead_stmt (gimple_stmt_iterator *i, basic_block bb)
 	  && !DECL_HAS_VALUE_EXPR_P (lhs))
 	{
 	  tree rhs = gimple_assign_rhs1 (stmt);
-	  gimple note
+	  gimple *note
 	    = gimple_build_debug_bind (lhs, unshare_expr (rhs), stmt);
 	  gsi_insert_after (i, note, GSI_SAME_STMT);
 	}
@@ -1145,7 +1145,7 @@ eliminate_unnecessary_stmts (void)
   bool something_changed = false;
   basic_block bb;
   gimple_stmt_iterator gsi, psi;
-  gimple stmt;
+  gimple *stmt;
   tree call;
   vec<basic_block> h;
 
@@ -1203,7 +1203,7 @@ eliminate_unnecessary_stmts (void)
 	      tree ptr = gimple_call_arg (stmt, 0);
 	      if (TREE_CODE (ptr) == SSA_NAME)
 		{
-		  gimple def_stmt = SSA_NAME_DEF_STMT (ptr);
+		  gimple *def_stmt = SSA_NAME_DEF_STMT (ptr);
 		  if (!gimple_nop_p (def_stmt)
 		      && !gimple_plf (def_stmt, STMT_NECESSARY))
 		    gimple_set_plf (stmt, STMT_NECESSARY, false);
diff --git a/gcc/tree-ssa-dom.c b/gcc/tree-ssa-dom.c
index 5b5adca..7683fb6 100644
--- a/gcc/tree-ssa-dom.c
+++ b/gcc/tree-ssa-dom.c
@@ -79,7 +79,7 @@ struct hashable_expr
     struct { enum tree_code op;  tree opnd; } unary;
     struct { enum tree_code op;  tree opnd0, opnd1; } binary;
     struct { enum tree_code op;  tree opnd0, opnd1, opnd2; } ternary;
-    struct { gimple fn_from; bool pure; size_t nargs; tree *args; } call;
+    struct { gimple *fn_from; bool pure; size_t nargs; tree *args; } call;
     struct { size_t nargs; tree *args; } phi;
   } ops;
 };
@@ -140,7 +140,7 @@ struct expr_hash_elt
   struct hashable_expr expr;
 
   /* The stmt pointer if this element corresponds to a statement.  */
-  gimple stmt;
+  gimple *stmt;
 
   /* The hash value for RHS.  */
   hashval_t hash;
@@ -174,10 +174,10 @@ expr_elt_hasher::hash (const value_type *p)
 inline bool
 expr_elt_hasher::equal (const value_type *p1, const compare_type *p2)
 {
-  gimple stmt1 = p1->stmt;
+  gimple *stmt1 = p1->stmt;
   const struct hashable_expr *expr1 = &p1->expr;
   const struct expr_hash_elt *stamp1 = p1->stamp;
-  gimple stmt2 = p2->stmt;
+  gimple *stmt2 = p2->stmt;
   const struct hashable_expr *expr2 = &p2->expr;
   const struct expr_hash_elt *stamp2 = p2->stamp;
 
@@ -252,7 +252,7 @@ static struct opt_stats_d opt_stats;
 
 /* Local functions.  */
 static void optimize_stmt (basic_block, gimple_stmt_iterator);
-static tree lookup_avail_expr (gimple, bool);
+static tree lookup_avail_expr (gimple *, bool);
 static hashval_t avail_expr_hash (const void *);
 static void htab_statistics (FILE *, hash_table <expr_elt_hasher>);
 static void record_cond (cond_equivalence *);
@@ -261,7 +261,7 @@ static void record_equality (tree, tree);
 static void record_equivalences_from_phis (basic_block);
 static void record_equivalences_from_incoming_edge (basic_block);
 static void eliminate_redundant_computations (gimple_stmt_iterator *);
-static void record_equivalences_from_stmt (gimple, int);
+static void record_equivalences_from_stmt (gimple *, int);
 static void remove_local_expressions_from_table (void);
 static void restore_vars_to_original_value (void);
 static edge single_incoming_edge_ignoring_loop_edges (basic_block);
@@ -271,7 +271,7 @@ static edge single_incoming_edge_ignoring_loop_edges (basic_block);
    by ELEMENT.  */
 
 static void
-initialize_hash_element (gimple stmt, tree lhs,
+initialize_hash_element (gimple *stmt, tree lhs,
                          struct expr_hash_elt *element)
 {
   enum gimple_code code = gimple_code (stmt);
@@ -626,7 +626,7 @@ iterative_hash_hashable_expr (const struct hashable_expr *expr, hashval_t val)
       {
         size_t i;
         enum tree_code code = CALL_EXPR;
-        gimple fn_from;
+        gimple *fn_from;
 
         val = iterative_hash_object (code, val);
         fn_from = expr->ops.call.fn_from;
@@ -703,7 +703,7 @@ print_expr_hash_elt (FILE * stream, const struct expr_hash_elt *element)
         {
           size_t i;
           size_t nargs = element->expr.ops.call.nargs;
-          gimple fn_from;
+          gimple *fn_from;
 
           fn_from = element->expr.ops.call.fn_from;
           if (gimple_call_internal_p (fn_from))
@@ -823,7 +823,7 @@ public:
 private:
   void thread_across_edge (edge);
 
-  gimple m_dummy_cond;
+  gimple *m_dummy_cond;
 };
 
 /* Jump threading, redundancy elimination and const/copy propagation.
@@ -995,7 +995,7 @@ make_pass_dominator (gcc::context *ctxt)
    condition to a canonical form.  */
 
 static void
-canonicalize_comparison (gimple condstmt)
+canonicalize_comparison (gimple *condstmt)
 {
   tree op0;
   tree op1;
@@ -1101,8 +1101,8 @@ restore_vars_to_original_value (void)
 /* A trivial wrapper so that we can present the generic jump
    threading code with a simple API for simplifying statements.  */
 static tree
-simplify_stmt_for_jump_threading (gimple stmt,
-				  gimple within_stmt ATTRIBUTE_UNUSED)
+simplify_stmt_for_jump_threading (gimple *stmt,
+				  gimple *within_stmt ATTRIBUTE_UNUSED)
 {
   return lookup_avail_expr (stmt, false);
 }
@@ -1185,7 +1185,7 @@ record_equivalences_from_phis (basic_block bb)
 
   for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple phi = gsi_stmt (gsi);
+      gimple *phi = gsi_stmt (gsi);
 
       tree lhs = gimple_phi_result (phi);
       tree rhs = NULL;
@@ -1299,7 +1299,7 @@ record_equivalences_from_incoming_edge (basic_block bb)
 	      && is_gimple_constant (rhs)
 	      && TREE_CODE (rhs) == INTEGER_CST)
 	    {
-	      gimple defstmt = SSA_NAME_DEF_STMT (lhs);
+	      gimple *defstmt = SSA_NAME_DEF_STMT (lhs);
 
 	      if (defstmt
 		  && is_gimple_assign (defstmt)
@@ -1567,7 +1567,7 @@ record_const_or_copy_1 (tree x, tree y, tree prev_x)
 int
 loop_depth_of_name (tree x)
 {
-  gimple defstmt;
+  gimple *defstmt;
   basic_block defbb;
 
   /* If it's not an SSA_NAME, we have no clue where the definition is.  */
@@ -1655,11 +1655,11 @@ record_equality (tree x, tree y)
    i_2 = i_1 +/- ...  */
 
 bool
-simple_iv_increment_p (gimple stmt)
+simple_iv_increment_p (gimple *stmt)
 {
   enum tree_code code;
   tree lhs, preinc;
-  gimple phi;
+  gimple *phi;
   size_t i;
 
   if (gimple_code (stmt) != GIMPLE_ASSIGN)
@@ -1744,7 +1744,7 @@ cprop_into_successor_phis (basic_block bb)
 	  tree new_val;
 	  use_operand_p orig_p;
 	  tree orig_val;
-          gimple phi = gsi_stmt (gsi);
+          gimple *phi = gsi_stmt (gsi);
 
 	  /* The alternative may be associated with a constant, so verify
 	     it is an SSA_NAME before doing anything with it.  */
@@ -1779,7 +1779,7 @@ record_edge_info (basic_block bb)
 
   if (! gsi_end_p (gsi))
     {
-      gimple stmt = gsi_stmt (gsi);
+      gimple *stmt = gsi_stmt (gsi);
       location_t loc = gimple_location (stmt);
 
       if (gimple_code (stmt) == GIMPLE_SWITCH)
@@ -1979,7 +1979,7 @@ dom_opt_dom_walker::before_dom_children (basic_block bb)
 void
 dom_opt_dom_walker::after_dom_children (basic_block bb)
 {
-  gimple last;
+  gimple *last;
 
   /* If we have an outgoing edge to a block with multiple incoming and
      outgoing edges, then we may be able to thread the edge, i.e., we
@@ -2032,7 +2032,7 @@ eliminate_redundant_computations (gimple_stmt_iterator* gsi)
   bool insert = true;
   bool assigns_var_p = false;
 
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
 
   if (gimple_code (stmt) == GIMPLE_PHI)
     def = gimple_phi_result (stmt);
@@ -2131,7 +2131,7 @@ eliminate_redundant_computations (gimple_stmt_iterator* gsi)
    lifing is done by eliminate_redundant_computations.  */
 
 static void
-record_equivalences_from_stmt (gimple stmt, int may_optimize_p)
+record_equivalences_from_stmt (gimple *stmt, int may_optimize_p)
 {
   tree lhs;
   enum tree_code lhs_code;
@@ -2181,7 +2181,7 @@ record_equivalences_from_stmt (gimple stmt, int may_optimize_p)
       && !is_gimple_reg (lhs))
     {
       tree rhs = gimple_assign_rhs1 (stmt);
-      gimple new_stmt;
+      gimple *new_stmt;
 
       /* Build a new statement with the RHS and LHS exchanged.  */
       if (TREE_CODE (rhs) == SSA_NAME)
@@ -2195,7 +2195,7 @@ record_equivalences_from_stmt (gimple stmt, int may_optimize_p)
              generate here may in fact be ill-formed, but it is simply
              used as an internal device in this pass, and never becomes
              part of the CFG.  */
-          gimple defstmt = SSA_NAME_DEF_STMT (rhs);
+          gimple *defstmt = SSA_NAME_DEF_STMT (rhs);
           new_stmt = gimple_build_assign (rhs, lhs);
           SSA_NAME_DEF_STMT (rhs) = defstmt;
         }
@@ -2214,7 +2214,7 @@ record_equivalences_from_stmt (gimple stmt, int may_optimize_p)
    CONST_AND_COPIES.  */
 
 static void
-cprop_operand (gimple stmt, use_operand_p op_p)
+cprop_operand (gimple *stmt, use_operand_p op_p)
 {
   tree val;
   tree op = USE_FROM_PTR (op_p);
@@ -2290,7 +2290,7 @@ cprop_operand (gimple stmt, use_operand_p op_p)
    vdef_ops of STMT.  */
 
 static void
-cprop_into_stmt (gimple stmt)
+cprop_into_stmt (gimple *stmt)
 {
   use_operand_p op_p;
   ssa_op_iter iter;
@@ -2317,7 +2317,7 @@ cprop_into_stmt (gimple stmt)
 static void
 optimize_stmt (basic_block bb, gimple_stmt_iterator si)
 {
-  gimple stmt, old_stmt;
+  gimple *stmt, *old_stmt;
   bool may_optimize_p;
   bool modified_p = false;
 
@@ -2413,7 +2413,7 @@ optimize_stmt (basic_block bb, gimple_stmt_iterator si)
 	  tree lhs = gimple_assign_lhs (stmt);
 	  tree rhs = gimple_assign_rhs1 (stmt);
 	  tree cached_lhs;
-	  gimple new_stmt;
+	  gimple *new_stmt;
 	  if (TREE_CODE (rhs) == SSA_NAME)
 	    {
 	      tree tem = SSA_NAME_VALUE (rhs);
@@ -2423,7 +2423,7 @@ optimize_stmt (basic_block bb, gimple_stmt_iterator si)
 	  /* Build a new statement with the RHS and LHS exchanged.  */
 	  if (TREE_CODE (rhs) == SSA_NAME)
 	    {
-	      gimple defstmt = SSA_NAME_DEF_STMT (rhs);
+	      gimple *defstmt = SSA_NAME_DEF_STMT (rhs);
 	      new_stmt = gimple_build_assign (rhs, lhs);
 	      SSA_NAME_DEF_STMT (rhs) = defstmt;
 	    }
@@ -2513,7 +2513,7 @@ optimize_stmt (basic_block bb, gimple_stmt_iterator si)
    we finish processing this block and its children.  */
 
 static tree
-lookup_avail_expr (gimple stmt, bool insert)
+lookup_avail_expr (gimple *stmt, bool insert)
 {
   expr_hash_elt **slot;
   tree lhs;
@@ -2599,7 +2599,7 @@ lookup_avail_expr (gimple stmt, bool insert)
 static hashval_t
 avail_expr_hash (const void *p)
 {
-  gimple stmt = ((const struct expr_hash_elt *)p)->stmt;
+  gimple *stmt = ((const struct expr_hash_elt *)p)->stmt;
   const struct hashable_expr *expr = &((const struct expr_hash_elt *)p)->expr;
   tree vuse;
   hashval_t val = 0;
@@ -2629,7 +2629,7 @@ avail_expr_hash (const void *p)
    remove it from the IL.  */
 
 static void
-remove_stmt_or_phi (gimple stmt)
+remove_stmt_or_phi (gimple *stmt)
 {
   gimple_stmt_iterator gsi = gsi_for_stmt (stmt);
 
@@ -2647,7 +2647,7 @@ remove_stmt_or_phi (gimple stmt)
    phi, NULL is returned.  */
 
 static tree
-get_rhs_or_phi_arg (gimple stmt)
+get_rhs_or_phi_arg (gimple *stmt)
 {
   if (gimple_code (stmt) == GIMPLE_PHI)
     return degenerate_phi_result (stmt);
@@ -2662,7 +2662,7 @@ get_rhs_or_phi_arg (gimple stmt)
    return the "lhs" of the node.  */
 
 static tree
-get_lhs_or_phi_result (gimple stmt)
+get_lhs_or_phi_result (gimple *stmt)
 {
   if (gimple_code (stmt) == GIMPLE_PHI)
     return gimple_phi_result (stmt);
@@ -2684,7 +2684,7 @@ get_lhs_or_phi_result (gimple stmt)
    opportunities.  */
 
 static void
-propagate_rhs_into_lhs (gimple stmt, tree lhs, tree rhs, bitmap interesting_names)
+propagate_rhs_into_lhs (gimple *stmt, tree lhs, tree rhs, bitmap interesting_names)
 {
   /* First verify that propagation is valid and isn't going to move a
      loop variant variable outside its loop.  */
@@ -2696,7 +2696,7 @@ propagate_rhs_into_lhs (gimple stmt, tree lhs, tree rhs, bitmap interesting_name
     {
       use_operand_p use_p;
       imm_use_iterator iter;
-      gimple use_stmt;
+      gimple *use_stmt;
       bool all = true;
 
       /* Dump details.  */
@@ -2869,7 +2869,7 @@ propagate_rhs_into_lhs (gimple stmt, tree lhs, tree rhs, bitmap interesting_name
                                !gsi_end_p (psi);
                                gsi_next (&psi))
                             {
-                              gimple phi = gsi_stmt (psi);
+                              gimple *phi = gsi_stmt (psi);
 
 			      tree result = gimple_phi_result (phi);
 			      int version = SSA_NAME_VERSION (result);
@@ -2921,7 +2921,7 @@ propagate_rhs_into_lhs (gimple stmt, tree lhs, tree rhs, bitmap interesting_name
    of STMT.  */
 
 static void
-eliminate_const_or_copy (gimple stmt, bitmap interesting_names)
+eliminate_const_or_copy (gimple *stmt, bitmap interesting_names)
 {
   tree lhs = get_lhs_or_phi_result (stmt);
   tree rhs;
@@ -2952,7 +2952,7 @@ eliminate_const_or_copy (gimple stmt, bitmap interesting_names)
     propagate_rhs_into_lhs (stmt, lhs, rhs, interesting_names);
   else
     {
-      gimple use_stmt;
+      gimple *use_stmt;
       imm_use_iterator iter;
       use_operand_p use_p;
       /* For virtual operands we have to propagate into all uses as
@@ -2984,7 +2984,7 @@ eliminate_degenerate_phis_1 (basic_block bb, bitmap interesting_names)
 
   for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple phi = gsi_stmt (gsi);
+      gimple *phi = gsi_stmt (gsi);
 
       eliminate_const_or_copy (phi, interesting_names);
     }
diff --git a/gcc/tree-ssa-dom.h b/gcc/tree-ssa-dom.h
index af2f128..bdb4d5f 100644
--- a/gcc/tree-ssa-dom.h
+++ b/gcc/tree-ssa-dom.h
@@ -23,6 +23,6 @@ along with GCC; see the file COPYING3.  If not see
 extern void dump_dominator_optimization_stats (FILE *);
 extern void debug_dominator_optimization_stats (void);
 extern int loop_depth_of_name (tree);
-extern bool simple_iv_increment_p (gimple);
+extern bool simple_iv_increment_p (gimple *);
 
 #endif /* GCC_TREE_SSA_DOM_H */
diff --git a/gcc/tree-ssa-dse.c b/gcc/tree-ssa-dse.c
index 4632add..63efa2d 100644
--- a/gcc/tree-ssa-dse.c
+++ b/gcc/tree-ssa-dse.c
@@ -87,9 +87,9 @@ static bitmap need_eh_cleanup;
    Return TRUE if the above conditions are met, otherwise FALSE.  */
 
 static bool
-dse_possible_dead_store_p (gimple stmt, gimple *use_stmt)
+dse_possible_dead_store_p (gimple *stmt, gimple **use_stmt)
 {
-  gimple temp;
+  gimple *temp;
   unsigned cnt = 0;
 
   *use_stmt = NULL;
@@ -108,7 +108,7 @@ dse_possible_dead_store_p (gimple stmt, gimple *use_stmt)
   temp = stmt;
   do
     {
-      gimple use_stmt, defvar_def;
+      gimple *use_stmt, *defvar_def;
       imm_use_iterator ui;
       bool fail = false;
       tree defvar;
@@ -223,7 +223,7 @@ dse_possible_dead_store_p (gimple stmt, gimple *use_stmt)
 static void
 dse_optimize_stmt (gimple_stmt_iterator *gsi)
 {
-  gimple stmt = gsi_stmt (*gsi);
+  gimple *stmt = gsi_stmt (*gsi);
 
   /* If this statement has no virtual defs, then there is nothing
      to do.  */
@@ -243,7 +243,7 @@ dse_optimize_stmt (gimple_stmt_iterator *gsi)
 
   if (is_gimple_assign (stmt))
     {
-      gimple use_stmt;
+      gimple *use_stmt;
 
       if (!dse_possible_dead_store_p (stmt, &use_stmt))
 	return;
